// -*- mode: c++ -*-
/* Copyright (C) 2003 MySQL AB

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

class NdbIndexOperation : public NdbOperation
{
public:

  %ndbexception("NdbApiException") {
    $action
      if (result==-1) { 
        NdbError err = arg1->getNdbError();
	NDB_exception(NdbApiException,err.message);
      }
  }

  /** insert is not allowed */
//  int insertTuple();
  voidint readTuple(LockMode);
  voidint updateTuple();
  voidint deleteTuple();


  voidint interpretedUpdateTuple();
  voidint interpretedDeleteTuple();
  
  %ndbexception("NdbApiException") {
    $action
      if (result==0) { 
        NdbError err = arg1->getNdbError();
	NDB_exception(NdbApiException,err.message);
      }
  }

  const NdbDictIndex * getIndex() const;

private:
  NdbIndexOperation(Ndb* aNdb);
  ~NdbIndexOperation();
};
