// -*- mode: c++ -*- 
/*  ndb-bindings: Wrappers for the NDB API
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

%include "globals.i"
%include "config.h"

%{

#include <my_global.h>
#include <my_sys.h>

#include <mysql.h>
#include <NdbApi.hpp>

/* These get included in mysql.h. Not sure they should... */
#undef PACKAGE
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#undef VERSION

#include "config.h"


  long long getMicroTime()
  {
    struct timeval tTime;
    gettimeofday(&tTime, 0);
    long long microSeconds = (long long) tTime.tv_sec * 1000000 + tTime.tv_usec;
    return microSeconds;
  }


/* voidint is a way to mark a method that returns int for SWIG
   to tell it we want the wrapped function to return void, but
   we don't want to discard the return value out of hand because
   we need it at the wrapping layer to find errors */
typedef int voidint;
typedef Uint32 NdbTimestamp;


typedef struct st_byte {
  char * theString;
  int theLength;
} BYTES;

class NdbDateTime
{
  public:
    unsigned int  year, month, day, hour, minute, second;
    NdbDateTime();
};

NdbDateTime::NdbDateTime() {
  year=0;
  month=0;
  day=0;
  hour=0;
  minute=0;
  second=0;
}

/* We don't just typedef these right in the first place
   because there because that would mean NdbDictionary::Dictionary
   would get renamed to NdbDictionary at the C level, which
   wouldn't work out so well. */

typedef NdbDictionary::Object NdbDictObject;
typedef NdbDictionary::Table NdbDictTable;
typedef NdbDictionary::Column NdbDictColumn;
typedef NdbDictionary::Index NdbDictIndex;
typedef NdbDictionary::Dictionary NdbDictDictionary;
typedef NdbDictionary::Event NdbDictEvent;


%}

%rename(NdbObject) NdbDictObject;
%rename(NdbTable) NdbDictTable;
%rename(NdbColumn) NdbDictColumn;
%rename(NdbIndex) NdbDictIndex;
%rename(NdbDictionary) NdbDictDictionary;
%rename(NdbEvent) NdbDictEvent;

/* Do this here so we can override it in the Java interface */
%rename(Ndb_cluster_connection) NdbClusterConnection;

long long getMicroTime();


enum AbortOption {
  CommitIfFailFree = 0,         
  TryCommit = 0,
  AbortOnError = 0,
  CommitAsMuchAsPossible = 2,
  AO_IgnoreError = 2
};

enum ExecType { 
  NoExecTypeDef = -1,
  Prepare = 0,
  NoCommit = 1,
  Commit = 2,
  Rollback = 3
};

typedef void (* NdbAsynchCallback)(int, NdbTransaction*, void*);
typedef void (* NdbEventCallback)(NdbEventOperation*, Ndb*, void*);

typedef const char * NdbDatetime;
typedef const char * NdbDate;
typedef const char * NdbTime; 
typedef Uint32 NdbTimestamp;


