package com.mysql.cluster.ndbj;

import com.mysql.cluster.ndbj.ndbjJNI;

public abstract class BaseCallback { 

  private long create_time;
  private long start_time;
  private long end_time;
  protected NdbTransaction theTrans = null;

  public BaseCallback(NdbTransaction trans) { 
    create_time = 0;
    start_time = 0;
    end_time = 0;
    theTrans=trans;
  }

  protected final void jni_call_callback(int result, long transPtr, long createTime) {
    this.create_time = createTime;
    this.start_time = this.getMicroTime();

    if (NdbTransactionImpl.getCPtr((NdbTransactionImpl)theTrans) == transPtr) {
        this.callback(result);//),new NdbTransactionImpl(transPtr,false));
    } else {
    	// Something is horrible wrong! The transaction we were passed is not the same as the 
    	// transaction we are storing. TODO: How do we deal with this?
    	this.callback(result);
    }	
    this.end_time = this.getMicroTime();
  };
  
  public abstract void callback(int result);

  //public void callback(int result, NdbTransaction myTrans) {}

  public final NdbError getNdbError() { 
	  return ((NdbTransactionImpl)theTrans).getNdbError();
  }
  public final long getMicroTime() { 
    return ndbjJNI.getMicroTime(); 
  }

  public final long getElapsedTime() { 
    return this.getMicroTime() - this.create_time; 
  }

  public final long getExecuteTime() { 
    return this.end_time - this.create_time; 
  }

  public final long getCallbackTime() { 
    return this.end_time - this.start_time; 
  }
  public final long getCreateTime() { 
    return this.create_time;
  }
  public final long getStartTime() { 
    return this.start_time; 
  }
};
