package com.mysql.cluster.ndbj;

import java.math.BigInteger;

import com.mysql.cluster.ndbj.NdbEvent.TableEvent;

public interface NdbEventOperation extends NdbEventOperationResults {


	/** 
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#execute()
	 */
	public abstract int execute() throws NdbApiException;

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#getAnyValue()
	 */
	public abstract long getAnyValue();


	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#getEventType()
	 */
	public abstract TableEvent getEventType();

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#getGCI()
	 */
	public abstract BigInteger getGCI();

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#getLatestGCI()
	 */
	public abstract BigInteger getLatestGCI();


	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#getState()
	 */
	public abstract State getState();


	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#isConsistent()
	 */
	public abstract boolean isConsistent();

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#isOverrun()
	 */
	public abstract int isOverrun() throws NdbApiException;

	/**
	 * @param flag
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#mergeEvents(boolean)
	 */
	public abstract void mergeEvents(boolean flag);

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#tableFragmentationChanged()
	 */
	public abstract boolean tableFragmentationChanged();

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#tableFrmChanged()
	 */
	public abstract boolean tableFrmChanged();

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#tableNameChanged()
	 */
	public abstract boolean tableNameChanged();

	/**
	 * @return
	 * @see com.mysql.cluster.ndbj.NdbEventOperation#tableRangeListChanged()
	 */
	public abstract boolean tableRangeListChanged();
	
	public NdbEventOperationImpl getImpl();
	
	  public enum State {
		    EO_CREATED,
		    EO_EXECUTING,
		    EO_DROPPED,
		    EO_ERROR;

		    public final int swigValue() {
		      return swigValue;
		    }

		    public static State swigToEnum(int swigValue) {
		      State[] swigValues = State.class.getEnumConstants();
		      if (swigValue < swigValues.length && swigValue >= 0 && swigValues[swigValue].swigValue == swigValue)
		        return swigValues[swigValue];
		      for (State swigEnum : swigValues)
		        if (swigEnum.swigValue == swigValue)
		          return swigEnum;
		      throw new IllegalArgumentException("No enum " + State.class + " with value " + swigValue);
		    }

		    private State() {
		      this.swigValue = SwigNext.next++;
		    }

		    @SuppressWarnings("unused")
		    private State(int swigValue) {
		      this.swigValue = swigValue;
		      SwigNext.next = swigValue+1;
		    }

		    @SuppressWarnings("unused")
		    private State(State swigEnum) {
		      this.swigValue = swigEnum.swigValue;
		      SwigNext.next = this.swigValue+1;
		    }

		    private final int swigValue;

		    private static class SwigNext {
		      private static int next = 0;
		    }
		  }

}
