package com.mysql.cluster.ndbj;

public interface NdbInterpretedOperation {

	public abstract void incValueLong(String anAttrName, long aValue)
			throws NdbApiException;

	public abstract void incValueLong(long anAttrId, long aValue)
			throws NdbApiException;

	public abstract void incValueUlong(String anAttrName,
			java.math.BigInteger aValue) throws NdbApiException;

	public abstract void incValueUlong(long anAttrId, java.math.BigInteger aValue)
			throws NdbApiException;

	public abstract void subValueLong(String anAttrName, long aValue)
			throws NdbApiException;

	public abstract void subValueUlong(String anAttrName,
			java.math.BigInteger aValue) throws NdbApiException;

	public abstract void subValueLong(long anAttrId, long aValue)
			throws NdbApiException;

	public abstract void subValueUlong(long anAttrId, java.math.BigInteger aValue)
			throws NdbApiException;

	public abstract void defLabel(int labelNumber) throws NdbApiException;

	public abstract void addReg(long RegSource1, long RegSource2, long RegDest)
			throws NdbApiException;

	public abstract void subReg(long RegSource1, long RegSource2, long RegDest)
			throws NdbApiException;

	public abstract void loadConstU32(long RegDest, long Constant)
			throws NdbApiException;

	public abstract void loadConstU64(long RegDest, java.math.BigInteger Constant)
			throws NdbApiException;

	public abstract void loadConstNull(long RegDest) throws NdbApiException;

	public abstract void readAttr(String anAttrName, long RegDest)
			throws NdbApiException;

	public abstract void writeAttr(String anAttrName, long RegSource)
			throws NdbApiException;

	public abstract void readAttr(long anAttrId, long RegDest)
			throws NdbApiException;

	public abstract void writeAttr(long anAttrId, long RegSource)
			throws NdbApiException;

	public abstract void branchGe(long RegLvalue, long RegRvalue, long Label)
			throws NdbApiException;

	public abstract void branchGt(long RegLvalue, long RegRvalue, long Label)
			throws NdbApiException;

	public abstract void branchLe(long RegLvalue, long RegRvalue, long Label)
			throws NdbApiException;

	public abstract void branchLt(long RegLvalue, long RegRvalue, long Label)
			throws NdbApiException;

	public abstract void branchEq(long RegLvalue, long RegRvalue, long Label)
			throws NdbApiException;

	public abstract void branchNe(long RegLvalue, long RegRvalue, long Label)
			throws NdbApiException;

	public abstract void branchNeNull(long RegLvalue, long Label)
			throws NdbApiException;

	public abstract void branchEqNull(long RegLvalue, long Label)
			throws NdbApiException;

	public abstract void branchLabel(long Label) throws NdbApiException;

	public abstract void branchColEqNull(long ColId, long Label)
			throws NdbApiException;

	public abstract void branchColNeNull(long ColId, long Label)
			throws NdbApiException;

	public abstract void interpretExitOk() throws NdbApiException;

	public abstract void interpretExitNok(long ErrorCode) throws NdbApiException;

	public abstract void interpretExitNok() throws NdbApiException;

	public abstract void interpretExitLastRow() throws NdbApiException;

	public abstract void defSubroutine(int SubroutineNumber)
			throws NdbApiException;

	public abstract void callSub(long Subroutine) throws NdbApiException;

	public abstract void retSub() throws NdbApiException;

	public abstract void branchColEq(long ColId, long val, long len,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColNe(long ColId, long val, long len,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColLt(long ColId, long val, long len,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColLe(long ColId, long val, long len,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColGt(long ColId, long val, long len,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColGe(long ColId, long val, long len,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColLikeString(long ColId, String anInputString,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColNotLikeString(long ColId,
			String anInputString, boolean nopad, long Label)
			throws NdbApiException;

	public abstract void branchColLikeBytes(long ColId, byte[] BYTE,
			boolean nopad, long Label) throws NdbApiException;

	public abstract void branchColNotLikeBytes(long ColId, byte[] BYTE,
			boolean nopad, long Label) throws NdbApiException;

}
