// -*- mode: c++ -*-
/*  ndb-bindings: Bindings for the NDB API
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

%module ndbj


%rename NdbBlob NdbBlobImpl;
%rename NdbClusterConnection NdbClusterConnectionImpl;
%rename NdbEventOperation NdbEventOperationImpl;
%rename NdbIndexOperation NdbIndexOperationImpl;
%rename NdbIndexScanOperation NdbIndexScanOperationImpl;
%rename NdbOperation NdbOperationImpl;
%rename NdbRecAttr NdbRecAttrImpl;
%rename Ndb NdbImpl;
%rename NdbScanFilter NdbScanFilterImpl;
%rename NdbScanOperation NdbScanOperationImpl;
%rename NdbTransaction NdbTransactionImpl;


%include "ndbapi/ndbglobals.i"
%include "various.i"
%include "enums.swg"


%include "asynch_callback_t.i"
%include "ndb_exception.i"

%include "voidint.i"

%include "NdbDateTime.i"

%include "timestamp.i"
%include "byte_array.i"

%include "names_array.i"

%include "input_string.i"

%typemap(javacode) SWIGTYPE %{
  @Override
  public boolean equals(Object obj) {
    boolean equal = false;
    if (obj instanceof $javaclassname)
      equal = ((($javaclassname)obj).swigCPtr == this.swigCPtr);
    return equal;
  }
  @Override
  public int hashCode() {
     return (int)getCPtr(this);
  }
%}


%include "NdbClusterConnection.i"
%include "Ndb.i"
%include "NdbDictionary.i"
%include "NdbTransaction.i"
%include "NdbOperation.i"
%include "NdbScanOperation.i"
%include "NdbIndexOperation.i"
%include "NdbIndexScanOperation.i"
%include "NdbEventOperation.i"

%include "NdbRecAttr.i"
%include "NdbBlob.i"

%include "NdbScanFilter.i"

%include "NdbError.i"
