// -*- mode: c++ -*-
/*  ndb-bindings: Bindings for the NDB API
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

%typemap(jni) NdbDateTime * "jobject"
%typemap(jtype) NdbDateTime * "Object"
%typemap(jstype) NdbDateTime * "java.util.Calendar"
%typemap(javain) NdbDateTime * "$javainput"
%typemap(javaout) NdbDateTime * { return (java.util.Calendar)$jnicall; }

%typemap(in) (NdbDateTime *) { 
   //   NdbDateTime * dt = (NdbDateTime *)malloc(sizeof(NdbDateTime));
   NdbDateTime * dt = new NdbDateTime();
   static jclass calendar_class = jenv->FindClass("java/util/Calendar");
   static jmethodID getID = jenv->GetMethodID(calendar_class,"get","(I)I");
   static jfieldID yearID = jenv->GetFieldID(calendar_class,"YEAR","I");
   static jfieldID monthID = jenv->GetFieldID(calendar_class,"MONTH","I");
   static jfieldID dayID = jenv->GetFieldID(calendar_class,"DAY","I");
   static jfieldID hourID = jenv->GetFieldID(calendar_class,"HOUR","I");
   static jfieldID minuteID = jenv->GetFieldID(calendar_class,"MINUTE","I");
   static jfieldID secondID = jenv->GetFieldID(calendar_class,"SECOND","I");
   static jint yearfield = jenv->GetIntField(calendar_class,yearID);
   static jint monthfield = jenv->GetIntField(calendar_class,monthID);
   static jint dayfield = jenv->GetIntField(calendar_class,dayID);
   static jint hourfield = jenv->GetIntField(calendar_class,hourID);
   static jint minutefield = jenv->GetIntField(calendar_class,minuteID);
   static jint secondfield = jenv->GetIntField(calendar_class,secondID);
   jint yearval = jenv->CallIntMethod($input,getID,yearfield);
   jint monthval = jenv->CallIntMethod($input,getID,monthfield);
   jint dayval = jenv->CallIntMethod($input,getID,dayfield);
   jint hourval = jenv->CallIntMethod($input,getID,hourfield);
   jint minuteval = jenv->CallIntMethod($input,getID,minutefield);
   jint secondval = jenv->CallIntMethod($input,getID,secondfield);
   // TODO: Need to add sanity checking here for signed/unsigned madness
   dt->year = (uint)yearval;
   dt->month = (uint)monthval;
   dt->day = (uint)dayval;
   dt->hour = (uint)hourval;
   dt->minute = (uint)minuteval;
   dt->second = (uint)secondval;
   $1 = dt;
 }

%typemap(out) (NdbDateTime *) { 
  static jclass calendar_class = jenv->FindClass("java/util/Calendar");
  static jmethodID get_calendar_instance = jenv->GetStaticMethodID(calendar_class,"getInstance","()Ljava/util/Calendar;");
  static jmethodID setID = jenv->GetMethodID(calendar_class,"set","(IIIIII)V");
  $result = jenv->CallObjectMethod(calendar_class,get_calendar_instance);
  jenv->CallVoidMethod($result,setID,$1->year,$1->month,$1->day,$1->hour,$1->minute,$1->second);

 }


%typemap(freearg) (NdbDateTime *) {
//  free((NdbDateTime *) $1);
    delete $1;
 }
