// -*- mode: c++ -*-
/*  ndb-bindings: Bindings for the NDB API
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

%{

#define NDB_exception(excp, msg) { ndb_throw_exception(jenv, #excp,msg);  } 
#define NDB_exception_err(excp, msg, err) { ndb_throw_exception(jenv, #excp,msg, err);  } 
  
  void ndb_throw_exception(JNIEnv *jenv, const char * excp, const char *msg) { 
    jclass clazz = NULL;
    const char * prefix = "com/mysql/cluster/ndbj/";
    if (strncmp(excp,"com.",4)==0) {
      clazz = jenv->FindClass(excp);
      if (clazz==NULL) {
	clazz = jenv->FindClass("java/lang/RuntimeException");
	jenv->ThrowNew(clazz,"Invalid exception class specified");
	return; 
      }
    } else { 
      char * exception = (char *)malloc(strlen(excp)+strlen(prefix)+1);
      strcpy(exception,prefix);
      strcat(exception,excp);
      
      clazz = jenv->FindClass(exception);
      free(exception);
      if (clazz==NULL) {
	clazz = jenv->FindClass("java/lang/RuntimeException");
	jenv->ThrowNew(clazz,"Invalid exception class specified");
	return; 
      }
    }
    
    jenv->ThrowNew(clazz,msg);
    jenv->DeleteLocalRef(clazz);
  }
  
  void ndb_throw_exception(JNIEnv *jenv, const char * excp, const char *msg, NdbError & err) { 
    jclass clazz = NULL; 
    const char * prefix = "com/mysql/cluster/ndbj/";
    if (strncmp(excp,"com.",4)==0) { 
      clazz = jenv->FindClass(excp);
      if (clazz==NULL) {
	clazz = jenv->FindClass("java/lang/RuntimeException");
	jenv->ThrowNew(clazz,"No callback method!");
	return; 
      }
    } else { 
      char * exception = (char *)malloc(strlen(excp)+strlen(prefix)+1);
      strcpy(exception,prefix);
      strcat(exception,excp);
      
      clazz = jenv->FindClass(exception);
      free(exception);
      if (clazz==NULL) {
	clazz = jenv->FindClass("java/lang/RuntimeException");
	jenv->ThrowNew(clazz,"Invalid exception class specified");
	return; 
      }
    }
    
    jlong errPtr = 0; 
    NdbError * result = new NdbError(err);
    errPtr = (jlong)result;
    
    jmethodID method = jenv->GetMethodID(clazz,"<init>","(J)V");
    jthrowable excpObj = (jthrowable)jenv->NewObject(clazz,method,errPtr);
    
    jenv->Throw(excpObj);
    
    jenv->DeleteLocalRef(clazz);
    jenv->DeleteLocalRef(excpObj);
  }
  
%}
