package testsuite;


import com.mysql.cluster.mgmj.NdbMgm;
import com.mysql.cluster.mgmj.NdbMgmException;
import com.mysql.cluster.mgmj.NdbMgmFactory;

import junit.framework.TestCase;

public class BaseMgmjTestCase extends TestCase {

	protected static final String CONFIG_FILENAME="ndbj.props";
	protected static String NDB_MGMD_CONNECTSTRING="";
	protected static String DB_NAME="test";
	protected static String TABLE_NAME="";
	protected static String LIB_PATH = "";
	protected static String USERNAME  = "root";
	protected static String PASSWORD = "";
	protected static String CLUSTER_LOG="";
	
	protected static NdbMgm mgm=null;

	static { 
  	    System.loadLibrary("ndbj");
	}
	
	public BaseMgmjTestCase(String arg0) {
		super(arg0);

	}

	@Override
	protected void setUp() throws Exception {
		super.setUp();

		/**
	      *  Connect to cluster, done once for each Application
	      */

        try {
		  mgm = NdbMgmFactory.createNdbMgm(NDB_MGMD_CONNECTSTRING);
		  mgm.connect(0,0,true);
        }
        catch (NdbMgmException e) {
			System.err.println("failed initialisation");
			assertFalse(true);
        }
	}

	@Override
	protected void tearDown() throws Exception {
		super.tearDown();
		mgm=null;
	}

}
