package testsuite.mgmj;

import testsuite.BaseMgmjTestCase;

import com.mysql.cluster.mgmj.NdbMgmException;
import com.mysql.cluster.mgmj.BackupStartOption;

public class BackupRestoreTest extends BaseMgmjTestCase {

	private static final BackupStartOption  WAIT_TYPE = BackupStartOption.WaitUntilBackupCompleted;
	private static final int BACKUP_ID =1;

	public BackupRestoreTest(String arg0) {
		super(arg0);
	}

	/*
	 * Test method for 'com.mysql.mgmapi.NdbMgm.startBackup(int, int)'
	 */
	public void testStartBackup() {

		long backupID;
		try {
			backupID = mgm.startBackup(WAIT_TYPE);
		System.out.println("Backup started with id="+backupID);
		assertTrue(true);
		}
		catch (NdbMgmException e) {
			System.err.println("Backup Failed:\t" + e.toString());
			assertFalse(true);
		}
	}

	/*
	 * Test method for 'com.mysql.mgmapi.NdbMgm.abortBackup(int)'
	 */
	public void testAbortBackup() {
		try {
			mgm.abortBackup(BACKUP_ID);
			assertTrue(true);
			}
			catch (NdbMgmException e) {
				System.err.println("Backup Failed");
				assertFalse(true);
			}
	}

}
