package testsuite.mgmj;


import testsuite.BaseMgmjTestCase;

import com.mysql.cluster.mgmj.NdbMgmException;

public class RestartNodeTest extends BaseMgmjTestCase {

	private static final int NODE_ID = 1;
	private static final int NODE_ID_TWO = 2;

	public static void main(String[] args) {
		junit.textui.TestRunner.run(RestartNodeTest.class);
	}

	public RestartNodeTest(String arg0) {
		super(arg0);
	}

	/*
	 * Test method for 'com.mysql.cluster.mgmj.NdbMgm.restart2(int, int[], int, int, int)'
	 */
	public final void testRestartAndWaitNoInitial() {
		try {
			mgm.restart(new int[]{NODE_ID},false,true,false);
			System.out.println("Restarting ndb, and putting it in waiting state");
			assertTrue(true);
		}
		catch (NdbMgmException e) {
			System.out.println(e.toString());
			assertFalse(true);
		}

	}

	/*
	 * Test method for 'com.mysql.cluster.mgmj.NdbMgm.start(int, int[])'
	 */
	public final void testStart() {

		try {
			wait(3000);
		}
		catch (InterruptedException e) {
			System.out.println("Awakend prematurely");
		}
		catch (IllegalMonitorStateException e) {
			System.out.println("current thread is not owner of the object's monitor");
		}

		try {
			mgm.start(new int[]{NODE_ID});
			assertTrue(true);
			System.out.println("Moving ndb from waiting state to started state");
		}
		catch (NdbMgmException e) {
			System.out.println(e.toString());
			assertFalse(true);

		}

	}

	/*
	 * Test method for 'com.mysql.cluster.mgmj.NdbMgm.restart(int, int[])'
	 */
	public final void testRestart() {
		try {
			mgm.restart(new int[]{NODE_ID_TWO});
			assertTrue(true);
			System.out.println("Restarting ndb fully");
		}
		catch (NdbMgmException e) {
			System.out.println(e.toString());
			assertFalse(true);
		}

	}


}
