package testsuite.ndbj;

import testsuite.BaseNdbjTestCase;
import com.mysql.cluster.ndbj.AbortOption;
import com.mysql.cluster.ndbj.ExecType;

import com.mysql.cluster.ndbj.NdbApiException;
import com.mysql.cluster.ndbj.NdbOperation; 
import java.sql.SQLException;


public class BasicTest extends BaseNdbjTestCase {

	String table_name = "basic_test";
	
	public BasicTest(String arg0) {
		super(arg0);
	}
	
	@Override
	public void setUp() throws Exception { 
		super.setUp();

		this.createTable(table_name, "(id int, name varchar(32), age int, primary key(id)) engine=ndbcluster");
		
	}

  
	public void testSingleInsertString() throws NdbApiException,SQLException { 
	


		trans = ndb.startTransaction();
		NdbOperation op = trans.getInsertOperation(table_name);
		op.equalInt("id", 1);
		op.setString("name", "Monty");
		trans.execute(ExecType.Commit,AbortOption.AbortOnError,true);
	
		String nameVal = (String)this.getSingleValue(table_name, "name", "where id=1");
		assertEquals("Monty",nameVal);
	}
	
	public void testSingleInsertInt() throws NdbApiException,SQLException { 
		
		trans = ndb.startTransaction();
		NdbOperation op = trans.getInsertOperation(table_name);
		op.equalInt("id", 1);
		op.setInt("age", 100);
		trans.execute(ExecType.Commit,AbortOption.AbortOnError,false);
		
		int nameVal = ((Integer)this.getSingleValue(table_name, "age", "where id=1")).intValue();		
		assertEquals(nameVal,100);
	}
}
