package testsuite.ndbj;

import testsuite.BaseNdbjTestCase;

import com.mysql.cluster.ndbj.NdbApiException;
import com.mysql.cluster.ndbj.NdbIndexScanOperation;
import com.mysql.cluster.ndbj.AbortOption;
import com.mysql.cluster.ndbj.ExecType;
import java.sql.SQLException;
import com.mysql.cluster.ndbj.NdbOperation.LockMode;


public class OrderedIndexScanTest extends BaseNdbjTestCase {

	protected String col1="id";
	protected String col2="name";
	protected String theTableName="t_oi_scan";
	protected static final int SELECT_COUNT=12000;

	public static void main(String[] args) {
		junit.textui.TestRunner.run(OrderedIndexScanTest.class);
	}

	public OrderedIndexScanTest(String arg0) {
		super(arg0);
	}

	@Override
	public void setUp() throws Exception {
		super.setUp();
		this.createTable(theTableName,
				"(`"+col1+"` INT, `"+col2+"` int, primary key (`"+col1+"`,`"+col2+"`)) ENGINE=ndbcluster;");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,1)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,2)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,3)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,4)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,5)");
	}

	public void testOIScan() {
		

		try {
			
			trans = ndb.startTransaction();
			trans.setOperationLockMode(LockMode.LM_CommittedRead);
			NdbIndexScanOperation iop=
				trans.getSelectIndexScanOperation("PRIMARY", theTableName);

			/*   System.out.println("foo");
			*/  
			iop.equalInt(0,1);
			
			
			assertEquals(NdbIndexScanOperation.BoundType.BoundEQ.type,4);
			/*
			iop.setBoundInt(col1, 
					NdbIndexScanOperation.BoundType.BoundEQ,
					1);
			*/
			long bound_no=0;
			iop.endOfBound(bound_no);


			iop.getValue(col1);
			iop.getValue(col2);

			rs = iop.resultData();
			trans.execute(ExecType.NoCommit, 
					AbortOption.AbortOnError, 
					true);



			int count=1;
			while(rs.next())
			{
				int col1Val = rs.getInt(col1);
				int col2Val = rs.getInt(col2);
				assertEquals(col1Val,1);
				assertEquals(col2Val,count);
				
				count++;
			}


			assertTrue(true);

	
		}
		catch (NdbApiException e) {
			System.out.println("Caught NdbApiException:\t" + e.getMessage() + e.getCode());
		}
		catch (SQLException e) {
			System.out.println("Caught NdbApiException:\t" + e.getMessage());
			assertTrue(false);
		}
		finally {
			if (trans!=null)
				trans.close(); 
		}

	}

}
