package testsuite.ndbj;

import java.math.BigInteger;

import testsuite.BaseNdbjTestCase;

import com.mysql.cluster.ndbj.NdbApiException;
import com.mysql.cluster.ndbj.NdbOperation;

import com.mysql.cluster.ndbj.AbortOption;
import com.mysql.cluster.ndbj.ExecType;

public class SelectCountTest extends BaseNdbjTestCase {

	protected String col1="id";
	protected String col2="name";
	protected String theTableName="t_select_count";
	protected static final int SELECT_COUNT=12000;

	public static void main(String[] args) {
		junit.textui.TestRunner.run(SelectCountTest.class);
	}

	public SelectCountTest(String arg0) {
		super(arg0);
	} 

	@Override
	public void setUp() throws Exception {
		super.setUp();
		this.createTable(theTableName,
		"(`"+col1+"` INT PRIMARY KEY, `"+col2+"` VARCHAR(256)) ENGINE=ndbcluster;");
				
	}

	/*
	 * Test method for 'com.mysql.ndbapi.Ndb.destroy()'
	 */
//	public void testInsertAndReadAndUpdateAndReadAndDeleteAndRead() {
//		// TODO Auto-generated method stub
//	}

	public void testInsert() {
		

		try {
			System.out.println("Inserting " + SELECT_COUNT
					+ " rows into table " + theTableName);
		    trans = ndb.startTransaction();

			System.out.println("Getting an operation object from table:\t" +theTableName);
			for (int i=0; i< SELECT_COUNT; i++) {
				NdbOperation op = trans.getInsertOperation(theTableName);
				op.equalInt(col1,i);
				String input = "jim".concat(Integer.toString(i));
				op.setString(col2,input);
			}

		    trans.execute(ExecType.Commit,
			      AbortOption.AbortOnError,
			      true);

		    trans.close();
		    
			System.out.println("Finished insert");
			assertTrue(true);

			System.out.println("Counting number of rows in table " + theTableName);
		    trans = ndb.startTransaction();

		    // TODO: Fix BigInteger selectCount() issues
		    BigInteger count = trans.selectCount(theTableName);
			System.out.println("Select count for :\t" + theTableName + " == " + count.longValue());
			assertEquals((count.compareTo(BigInteger.ZERO) < 0), false);

			trans.close();
			
			System.out.println("Deleting the inserted rows");
		    trans = ndb.startTransaction();


		    for (int i=0;i<SELECT_COUNT; i++) {
		    	NdbOperation op = trans.getDeleteOperation(theTableName);
		    	op.equalInt(col1,i);
		    }

		    trans.execute(ExecType.Commit,
			      AbortOption.AbortOnError,
			      true);

			System.out.println("Finished delete");
			assertTrue(true);
		}
		catch (NdbApiException e) {
			System.out.println("Caught NdbApiException:\t" + e.getMessage());
			assertTrue(false);
		}
		finally {
			/*if (trans!=null)
				trans.close();*/
		}

	}

}
