// -*- mode: c++ -*-
/*  ndb-bindings: Bindings for the NDB API
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

%module(directors="1") mgmapi

%typemap(out) (BaseEventWrapper *) %{
  //Monty
  $result = SWIG_NewPointerObj(SWIG_as_voidptr(result->theEvent), SWIGTYPE_p_ndb_logevent, SWIG_POINTER_OWN |  0 );  
 %}


%include "mgmapi/mgmglobals.i"
%include "mgmapi/NdbLogEvent.i"
%include "mgmapi/NdbLogEventManager.i"
%include "mgmapi/NdbMgm.i"
%include "mgmapi/NdbMgmFactory.i"
%include "mgmapi/ClusterState.i"
%include "mgmapi/NodeState.i"
%include "mgmapi/NdbMgmReply.i"

extern int ndb_init(void);

%init %{
  ndb_init();

  NEW_pyexcept(NdbApiException,NULL);
  NEW_pyexcept(NdbApiRuntimeException,PyExc_NdbApiException);
  NEW_pyexcept(NdbApiPermanentException,PyExc_NdbApiException);
  NEW_pyexcept(NdbApiTemporaryException,PyExc_NdbApiException);
  NEW_pyexcept(NdbApiUserErrorPermanentException,PyExc_NdbApiPermanentException);
  NEW_pyexcept(NdbClusterConnectionPermanentException,PyExc_NdbApiPermanentException);
  NEW_pyexcept(NdbClusterConnectionTemporaryException,PyExc_NdbApiTemporaryException);
  NEW_pyexcept(NdbApiTimeStampOutOfBoundsException,PyExc_NdbApiException);
  NEW_pyexcept(BlobUndefinedException,PyExc_NdbApiException);
  NEW_pyexcept(NoSuchColumnException,PyExc_NdbApiException);
  NEW_pyexcept(NoSuchIndexException,PyExc_NdbApiException);
  NEW_pyexcept(NoSuchTableException,PyExc_NdbApiException);

%}

%{

#define NEW_pyexcept(EXCPT,EPARENT) { PyExc_ ## EXCPT = PyErr_NewException("mysql.cluster.ndbapi." #EXCPT ,EPARENT,NULL); PyDict_SetItemString(d, #EXCPT ,PyExc_ ## EXCPT); Py_INCREF(PyExc_ ## EXCPT); }
  
  PyObject * PyExc_NdbApiException; 
  PyObject * PyExc_BlobUndefinedException;
  PyObject * PyExc_NdbApiPermanentException;
  PyObject * PyExc_NdbApiRuntimeException;
  PyObject * PyExc_NdbApiTemporaryException;
  PyObject * PyExc_NdbApiTimeStampOutOfBoundsException;
  PyObject * PyExc_NdbApiUserErrorPermanentException;
  PyObject * PyExc_NdbClusterConnectionPermanentException;
  PyObject * PyExc_NdbClusterConnectionTemporaryException;
  PyObject * PyExc_NoSuchColumnException;
  PyObject * PyExc_NoSuchIndexException;
  PyObject * PyExc_NoSuchTableException;
  
#define NDB_exception(excp, msg) { ndb_throw_exception(excp,msg); SWIG_fail; }
  
  void ndb_throw_exception(NdbException excp_mod, const char * msg) { 
    
    PyObject * exception; 
    
    switch (excp_mod) { 
    case NdbApiException:
      exception = PyExc_NdbApiException;
      break; 
    case BlobUndefinedException:
      exception = PyExc_BlobUndefinedException;
      break;
    case NdbApiPermanentException:
      exception = PyExc_NdbApiPermanentException;
      break;
    case NdbApiRuntimeException:
      exception = PyExc_NdbApiRuntimeException;
      break;
    case NdbApiTemporaryException:
      exception = PyExc_NdbApiTemporaryException;
      break;
    case NdbApiTimeStampOutOfBoundsException:
      exception = PyExc_NdbApiTimeStampOutOfBoundsException;
      break;
    case NdbApiUserErrorPermanentException:
      exception = PyExc_NdbApiUserErrorPermanentException;
      break;
    case NdbClusterConnectionPermanentException:
      exception = PyExc_NdbClusterConnectionPermanentException;
      break;
    case NdbClusterConnectionTemporaryException:
      exception = PyExc_NdbClusterConnectionTemporaryException;
      break;
    case NoSuchColumnException:
      exception = PyExc_NoSuchColumnException;
      break;
    case NoSuchIndexException:
      exception = PyExc_NoSuchIndexException;
      break;
    case NoSuchTableException:
      exception = PyExc_NoSuchTableException;
      break;
    default:
      exception = PyExc_RuntimeError;
    }
    exception = PyExc_NdbApiException;
    PyErr_SetString(exception,msg);
    Py_INCREF(exception);  
  }
  
  
  
  %}


