import unittest
import MySQLdb
from mysql.cluster import ndbapi
from mysql.cluster.tests import shared_cluster_connection


class ClusterTestCase(unittest.TestCase):

  MYSQLD_HOST=""
  NDB_MGMD_CONNECTSTRING=""
  DB_NAME="test"
  TABLE_NAME=""
  LIB_PATH = ""
  USERNAME  = "root"
  PASSWORD = ""
  CLUSTER_LOG=""
  MYSQL_CONN=None


  def createTable(self, tableName, schemaDefinition):

    self.TABLE_NAME=tableName

      
    cur=self.MYSQL_CONN.cursor()

    cur.execute("drop table if exists %s" % self.TABLE_NAME)

    cur.execute("create table %s %s " % (tableName,schemaDefinition))

  
  def setUp(self):

    self.MYSQL_CONN=MySQLdb.connect(
      host=self.MYSQLD_HOST,
      user=self.USERNAME,
      passwd=self.PASSWORD,
      db=self.DB_NAME,
      read_default_group="client")

    #if conn is None:
    #  conn = ndbapi.NdbFactory.createNdbClusterConnection(self.NDB_MGMD_CONNECTSTRING)
   # 
   #   conn.connect(5,3,1)
   #   conn.wait_until_ready(30,30)

    self.ndb = shared_cluster_connection.conn.createNdb(self.DB_NAME)
    self.ndb.init(1000)

##   def tearDown(self):
    
##     del self.ndb
##     del self.conn
