import ClusterTestCase
from mysql.cluster import ndbapi
import unittest

class NdbTest(ClusterTestCase.ClusterTestCase):


    PRIMARYKEYINDEXNAME = "PRIMARY"
    
    TABLE1 = "table1"
    TABLE2 = "table2"
    TABLE3 = "table3"
    key1   = "k1"
    key2   = "k2"
    data1  = "d1"
    data2  = "d2"
    data3  = "d3"
    data4  = "d4"
    data5  = "d5"
    data6  = "d6"
    data7  = "d7"
    
    rowTable1 = "rob"
    rowTable2 = "james"
    rowTable3 = "maeve"


    def setUp(self):
        super(NdbTest, self).setUp()
        
        self.createTable(self.TABLE1,"""
        ( k1 VARCHAR(30) NOT NULL, d1 VARCHAR(20),
        d2 INTEGER, primary key (k1) ) engine=ndbcluster;""")

        self.createTable(self.TABLE2,"""
        ( k1 VARCHAR(256) NOT NULL, k2 INTEGER NOT NULL, d1 VARCHAR(256),
        d2 INTEGER, primary key (k1, k2) ) engine=ndbcluster;""")

        self.createTable(self.TABLE3,"""
        ( k1 VARCHAR(256) NOT NULL, d1 TIMESTAMP, d2 CHAR(1),
        d3 VARBINARY(100), d4 BLOB, d5 TEXT, d6 BIGINT,
        d7 BLOB, PRIMARY KEY (k1)) engine=ndbcluster;""")

    def testInsertTable1(self):

        trans = self.ndb.startTransaction();
        
        op = trans.getNdbOperation(self.TABLE1);
        
        op.insertTuple();
        
        op.setString( self.key1, self.rowTable1)
        op.setNull( self.data1  )
        op.setInt(self.data2, 42)
        
        trans.execute(ndbapi.Commit)
        
        trans.close()


    def runInsertTable1(self):
        trans = self.ndb.startTransaction();
        
        op = trans.getNdbOperation(self.TABLE1);
        
        op.insertTuple();
        
        op.setString( self.key1, self.rowTable1)
        op.setString( self.data1 , "mynewvalue" )
        op.setInt(self.data2, 42)
        
        trans.execute(ndbapi.Commit)
        trans.close()
        
    def testInsertTable1ExpectingError(self):

        self.assertRaises(ndbapi.NdbApiException,self.runInsertTable1)

                    


test_all = unittest.TestLoader().loadTestsFromTestCase(NdbTest)
        
if __name__=="__main__":
    #unittest.main()
    
    unittest.TextTestRunner(verbosity=2).run(suite)
