import sys,time,random
from mysql.cluster import ndbapi

if len(sys.argv) != 3:
  print "Usage:\n\ttest.py NUM_OF_ITERATIONS NUM_OF_ROWS "
  sys.exit(1)

num_iter=sys.argv[1]
INSERT_NUM=sys.argv[2]


print "connecting to cluster\n"

#ndb.ndb_init()

connection = ndbapi.NdbFactory.createNdbClusterConnection()

if (connection.connect(5,3,1)):

    print "Connect to cluster management server failed."
    sys.exit(-1)
    
    
if (connection.waitUntilReady(30,30)):
    print "Cluster was not ready within 30 secs."
    sys.exit(-1);


myNdb = connection.createNdb("test" )

if (myNdb.init(4) == -1):
    print myNdb.getNdbError()
    sys.exit(-1)


print "running tests:\n"

### Get list of ids
    
myTransaction = myNdb.startTransaction()


myScanOperation=myTransaction.getNdbScanOperation("mytablename");


if myScanOperation is None:
    print myTransaction.getNdbError();


if myScanOperation.readTuples(ndbapi.NdbOperation.LM_CommittedRead):
    print myScanOperation.getNdbError();


    
myRecAttr=myScanOperation.getValue("ATTR1");
    
    
myTransaction.execute(ndbapi.NoCommit);

ids=[]
while 1:
      
    if (myScanOperation.nextResult(True) != 0) :
        break
      
    random_id = myRecAttr.getValue()
    ids.append(random_id)

print ids
    
myTransaction.close()


### Fetch ids using ndb

before_t = time.time()

for f in range(0,int(num_iter)):

    myTrans = myNdb.startTransaction()
    if myTrans is None:
        print myNdb.getNdbError()

    myOper = myTrans.getNdbOperation("mytablename")
    myOper.readTuple(ndbapi.NdbOperation.LM_Read)

    id_num = ids[random.randrange(0,len(ids))]
    myOper.equalUint64("ATTR1",id_num)
            
    myRecAttr= myOper.getValue("ATTR2")
    
    if myTrans.execute( ndbapi.Commit ) == -1:
        print myTrans.getNdbError()
    bar=myRecAttr.aRef()
    print "bar:", bar
    #foo=myRecAttr.getValue()
    myTrans.close()
      

#ndb.ndb_end(0)
after_t = time.time()
print "NDBAPI time for %s: %s -- %s" % ( num_iter, after_t, before_t)
print "\t %s" % (after_t - before_t)

