require 'mysql/cluster/ndbapi'

class NdbCallback 
  def initialize(myRecAttr)
    @myRecAttr=myRecAttr
  end
  def call(trans)
    puts @myRecAttr.get_int32
  end
end  

Ndbapi::ndb_init

num_iter=ARGV[0]
insert_num=ARGV[1]

BATCH_SIZE=10

puts "Connecting to cluster"

#connection=Ndbapi::NdbFactory.createNdbClusterConnection()
connection=Ndbapi::NdbFactory.create_ndb_cluster_connection("127.0.0.1")

begin
  connection.connect(1,1,1)
  connection.wait_until_ready(30, 30)

rescue NdbApiException => e
  puts "ERROR:" + e
  exit 
end

myNdb = connection.create_ndb("test")

myNdb.init(4) 

puts "running tests"

myTransaction = myNdb.start_transaction

myOperation = myTransaction.get_ndb_operation("mytablename")
myOperation.insert_tuple
auto_id = myNdb.get_auto_increment_value("mytablename",BATCH_SIZE)

puts "Inserting" , auto_id

myOperation.equal("ATTR1",auto_id)
myOperation.set_value("ATTR2",1234)

myTransaction.execute(Ndbapi::Commit)

myTransaction.close

myTransaction = myNdb.start_transaction

myOperation = myTransaction.get_ndb_operation("mytablename")
myOperation.read_tuple(Ndbapi::NdbOperation::LM_Read)

myOperation.equal("ATTR1", auto_id)
myRecAttr = myOperation.get_value("ATTR2")

cb=NdbCallback.new(myRecAttr)

myTransaction.execute_asynch_prepare(Ndbapi::Commit,cb)

myNdb.send_poll_ndb(3000,1)

